
import edu.jhu.pha.skyservice.*;
import net.voservices.spectrum.*;

public class Spectra {
  public Spectra() {

	try {
// Proxy, URL of the service
	  System.out.println("\n-->Spectra Web Service URL");
	  SearchLocator wl = new SearchLocator();
	  System.out.println(wl.getSearchSoapAddress());
	  SearchSoap p = wl.getSearchSoap();

// Retrieving a spectrum by its ID
	  System.out.println("\n-->Retrieving a spectrum by its ID (example 200000)");
	  Spectrum s = p.getSpectrum(200000, true);
	  System.out.println(s.getName());
	  for (int i = 0; i < 10; i++) {
		System.out.println
			("\t" + s.getPoints().getPoint()[i].getWavelength() + " " +
			 s.getPoints().getPoint()[i].getValue());
	  }
// Retrieving a spectrum by its ID (in VOTable format)
	  System.out.println("\n-->Retrieving a spectrum by its ID (example 200000) in VOTable format");
	  VOTABLE v = p.getSpectrumVoTable(200000, false);
	  System.out.print(v.getDESCRIPTION() + ": ");
	  System.out.println(v.getRESOURCE()[0].getTABLE()[0].getDATA().
						 getTABLEDATA().getTR()[0].getTD()[1].getValue());

// Returning spectra in a virtual observational field
	  System.out.println("\n-->Returning spectra in a virtual observational field");
	  ArrayOfSpectrum aos = p.findSpectraCone(180, 0, 5, false);
	  Spectrum[] sa = aos.getSpectrum();
	  System.out.println("# of objects found: " + sa.length);
	  Spectrum c = null;
	  for (int si = 0; si < sa.length; si++) {
		c = sa[si];
		System.out.println("\t" + c.getRa() + "\t" + c.getDec());
	  }
	}
	catch (Exception f) {System.out.println(f.toString());};
  }

  public static void main(String[] args) throws Exception {
	new Spectra();
  }
}
